import numpy as np
import cv2
import itertools
import random

def make_block(t_colors, colors, order):
    image = np.zeros((200, 200, 3), dtype=np.uint8)
    for i in range(200):
        for j in range(200):
            if template[i, j, 0] == t_colors[order[0]]:
                image[i, j] = colors[0][i, j]
            if template[i, j, 0] == t_colors[order[1]]:
                image[i, j] = colors[1][i, j]
            if template[i, j, 0] == t_colors[order[2]]:
                image[i, j] = colors[2][i, j]
            if template[i, j, 0] == t_colors[order[3]]:
                image[i, j] = colors[3][i, j]
    return image

image = np.zeros((800, 1200, 3), dtype=np.uint8)

template = cv2.imread("small_template.png")
template = cv2.cvtColor(template, cv2.COLOR_BGR2HSV)

template_colors = [120, 60, 0, 30]

orders = list(itertools.permutations([0, 1, 2, 3]))
random.shuffle(orders)

brown = cv2.imread("brown.png")
orange = cv2.imread("orange.png")
blue = cv2.imread("blue.png")
cyan = cv2.imread("cyan.png")

colors = [brown, orange, blue, cyan]

quilt = []

for i in range(len(orders)):
    quilt.append(make_block(template_colors, colors, orders[i]))

for b in range(24):
    col = int(b % 4)
    row = int(b / 4)
    col_start = col * 200
    row_start = row * 200
    for i in range (200):
        for j in range(200):
            image[i + col_start, j + row_start] = quilt[b][i, j]

cv2.imshow("image", image)
cv2.waitKey(0)
cv2.imwrite("test_quilt_3.png", image)
